1 #!/usr/bin/ksh
2
3 #
4 # This file and its contents are supplied under the terms of the
5 # Common Development and Distribution License ("CDDL"), version 1.0.
6 # You may only use this file in accordance with the terms of version
7 # 1.0 of the CDDL.
8 #
9 # A full copy of the text of the CDDL should have accompanied this
10 # source. A copy of the CDDL is also available via the Internet at
11 # http://www.illumos.org/license/CDDL.
12 #
13
14 #
15 # Copyright (c) 2012, 2016 by Delphix. All rights reserved.
16 # Copyright 2014, OmniTI Computer Consulting, Inc. All rights reserved.
17 # Copyright 2016 Nexenta Systems, Inc.
18 #
19
20 export PATH="/usr/bin"
21 export NOINUSE_CHECK=1
22 export STF_SUITE="/opt/zfs-tests"
23 export STF_TOOLS="/opt/test-runner/stf"
24 export PATHDIR=""
25 runner="/opt/test-runner/bin/run"
26 auto_detect=false
27
28 function fail
29 {
30 echo $1
31 exit ${2:-1}
32 }
33
34 function find_disks
35 {
36 typeset all_disks=$(echo '' | sudo -k format | awk \
37 '/c[0-9]/ {print $2}')
38 typeset used_disks=$(zpool status | awk \
39 '/c[0-9]*t[0-9a-f]*d[0-9]/ {print $1}' | sed 's/s[0-9]//g')
40
41 typeset disk used avail_disks
42 for disk in $all_disks; do
43 for used in $used_disks; do
44 [[ "$disk" = "$used" ]] && continue 2
45 done
46 [[ -n $avail_disks ]] && avail_disks="$avail_disks $disk"
47 [[ -z $avail_disks ]] && avail_disks="$disk"
48 done
49
50 echo $avail_disks
51 }
52
53 function find_rpool
54 {
55 typeset ds=$(mount | awk '/^\/ / {print $3}')
56 echo ${ds%%/*}
57 }
58
59 function find_runfile
60 {
61 typeset distro=
62 if [[ -d /opt/delphix && -h /etc/delphix/version ]]; then
63 distro=delphix
64 elif [[ 0 -ne $(grep -c OpenIndiana /etc/release 2>/dev/null) ]]; then
65 distro=openindiana
66 elif [[ 0 -ne $(grep -c OmniOS /etc/release 2>/dev/null) ]]; then
67 distro=omnios
68 fi
69
70 [[ -n $distro ]] && echo $STF_SUITE/runfiles/$distro.run
71 }
72
73 function verify_id
74 {
75 [[ $(id -u) = "0" ]] && fail "This script must not be run as root."
76
77 sudo -k -n id >/dev/null 2>&1
78 [[ $? -eq 0 ]] || fail "User must be able to sudo without a password."
79 }
80
81 function verify_disks
82 {
83 typeset disk
84 for disk in $DISKS; do
85 sudo -k prtvtoc /dev/rdsk/${disk}s0 >/dev/null 2>&1
86 [[ $? -eq 0 ]] || return 1
87 done
88 return 0
89 }
90
91 function create_links
92 {
93 typeset dir=$1
94 typeset file_list=$2
95
96 [[ -n $PATHDIR ]] || fail "PATHDIR wasn't correctly set"
97
98 for i in $file_list; do
99 [[ ! -e $PATHDIR/$i ]] || fail "$i already exists"
100 ln -s $dir/$i $PATHDIR/$i || fail "Couldn't link $i"
101 done
102
103 }
104
105 function constrain_path
106 {
107 . $STF_SUITE/include/commands.cfg
108
109 PATHDIR=$(/usr/bin/mktemp -d /var/tmp/constrained_path.XXXX)
110 chmod 755 $PATHDIR || fail "Couldn't chmod $PATHDIR"
111
112 create_links "/usr/bin" "$USR_BIN_FILES"
113 create_links "/usr/sbin" "$USR_SBIN_FILES"
114 create_links "/sbin" "$SBIN_FILES"
115 create_links "/opt/zfs-tests/bin" "$ZFSTEST_FILES"
116
117 # Special case links
118 ln -s /usr/gnu/bin/dd $PATHDIR/gnu_dd
119 }
120
121 constrain_path
122 export PATH=$PATHDIR
123
124 verify_id
125 while getopts ac:q c; do
126 case $c in
127 'a')
128 auto_detect=true
129 ;;
130 'c')
131 runfile=$OPTARG
132 [[ -f $runfile ]] || fail "Cannot read file: $runfile"
133 ;;
134 'q')
135 quiet='-q'
136 ;;
137 esac
138 done
139 shift $((OPTIND - 1))
140
141 # If the user specified -a, then use free disks, otherwise use those in $DISKS.
142 if $auto_detect; then
143 export DISKS=$(find_disks)
144 elif [[ -z $DISKS ]]; then
145 fail "\$DISKS not set in env, and -a not specified."
146 else
147 verify_disks || fail "Couldn't verify all the disks in \$DISKS"
148 fi
149
150 # Add the root pool to $KEEP according to its contents.
151 # It's ok to list it twice.
152 if [[ -z $KEEP ]]; then
153 KEEP="$(find_rpool)"
154 else
155 KEEP+=" $(find_rpool)"
156 fi
157
158 export __ZFS_POOL_EXCLUDE="$KEEP"
159 export KEEP="^$(echo $KEEP | sed 's/ /$|^/g')\$"
160
161 [[ -z $runfile ]] && runfile=$(find_runfile)
162 [[ -z $runfile ]] && fail "Couldn't determine distro"
163
164 . $STF_SUITE/include/default.cfg
165
166 num_disks=$(echo $DISKS | awk '{print NF}')
167 [[ $num_disks -lt 3 ]] && fail "Not enough disks to run ZFS Test Suite"
168
169 # Ensure user has only basic privileges.
170 ppriv -s EIP=basic -e $runner $quiet -c $runfile
171 ret=$?
172
173 rm -rf $PATHDIR || fail "Couldn't remove $PATHDIR"
174
175 exit $ret